
# R-code 1 for ``A step-up test procedure to find the minimum effective dose''

# 1. Compute the pava estimates in Table 1 under one-way anova setting 
# 2. Input: k sample means and k sample sizes. (ybar1,n1),...,(ybark,nk)
# 3. Output: k numbers, the estimates of the k means with non-decreasing 
#    proporty. mu1,...,muk that are nondecreasing.

ybar=c(23.9, 27.7, 33.4, 40.5, 57.9, 74.4, 73.4, 73.5, 76.2) # ybar's, the sample means
                                                             # in Example 1 without control.
ni=c(6,6,6,6,6,6,6,6,6)  # ni's, the sample sizes, in Example 1
mui=ni           # the pava estimates to be computed
kk=length(ybar)

outp=cbind(ybar,ni,mui)  # the output contains ybar, ni and pava

for (i in 1:kk){
  mins=1:i
  for (s in 1:i){
    maxst=i:kk
    for (t in i:kk){
      ll=outp[s:t,] 
      if (length(ll)==3){maxst[t-i+1]=ll[1]*ll[2]/ll[2]}
      else {maxst[t-i+1]=(sum(ll[,1]*ll[,2]))/sum(ll[,2])}
    }
    mins[s]=min(maxst)
  }
  outp[i,3]=max(mins)
}

outp  # this inlcludes ybar(1st column), ni (2nd) and pava (3rd).