
# R-code 2 for ``A step-up test procedure to find the minimum effective dose''

# 1. To compute the cutoff ci's of our proposed method when i=1,....,k (k=9), 
# in Example 1(continued), and the pava is computed using the max-min formula


# 2. Input: k, the number of doses(without control); 
#    ni, the sample sizes; alpha, the test level

# 3. Output: ci=(c1,...,ck)  

tim=proc.time()
alpha=0.05         # the test level
k=9                # the number of doses
ni=6+0*(0:k)       # the sample sizes
simu=1000000        # the number of simulations
                   # when simu=100000, it takes about 13 minutes for
                   # c1,...,c9 in Example 1.  


ci=1:k
nu=sum(ni)-k-1     # the df of error
ci[1]=qt(1-alpha,nu)*sqrt(1/ni[k+1]+1/ni[1])  # this is c1(alpha)

pava<-function(ybar,ni){     # this computes pava estimates, 
                             # ybar=(ybar1,...,ybark), ni-(n1,...,nk)
inpu=cbind(ybar,ni)
outp=inpu
kk=length(ybar)
for (i in 1:kk){
  mins=1:i
  for (s in 1:i){
    maxst=i:kk
    for (t in i:kk){
      ll=inpu[s:t,] 
      if (length(ll)==2){maxst[t-i+1]=ll[1]*ll[2]/ll[2]}
      else {maxst[t-i+1]=(sum(ll[,1]*ll[,2]))/sum(ll[,2])}
    }
    mins[s]=min(maxst)
  }
  outp[i,1]=max(mins)
}
return(outp)   # provide pava's and ni
}


z0=rnorm(simu)/sqrt(ni[k+1])
zi=array(,dim=c(simu,k))
for (i in 1:k){
zi[,i]=rnorm(simu)/sqrt(ni[i])
}
ss=sqrt(rchisq(simu,nu)/nu)
sda=cbind(zi,z0,ss)

for (jj in 2:k){
   freq=cbind(sda[,1:jj], sda[,(k+1):(k+2)])
   freq1=freq
      for (ii in 1:simu){
      nume=pava(freq[ii,1:jj],ni[1:jj])
      freq1[ii,1:(jj-1)]=(nume[1:(jj-1),1]-z0[ii])/ss[ii]>ci[1:(jj-1)]
      if (sum(freq1[ii,1:(jj-1)])>0.5){freq1[ii,jj]=10^10}
      else {freq1[ii,jj]=(nume[jj]-z0[ii])/ss[ii]}
      }
   aa=freq1[order(freq1[,jj]),jj]
   ci[jj]=aa[floor((1-alpha)*simu)]
}

ci

(proc.time()-tim)/60