
# R-code 3 for ``A step-up test procedure to find the minimum effective dose''

# 1. Compute the test statistics for Example 1(continued)
# 2. Input: k+1 sample means, k+1 sample sizes and k+1 sample 
#    standard deviations. (ybar0,n0,s0),...,(ybark,nk,sk), where k is the 
#    number of dose levels(excluding the control group)
# 3. Output: k numbers, (mui(pava)-ybar0-delta)/s for i=1,...,k

delta=6.5   # a number for dose to be effective
ybar=c(25.5, 23.9, 27.7, 33.4, 40.5, 57.9, 74.4, 73.4, 73.5, 76.2) 
# ybar's, the sample means in Example 1 with the control.
ni=c(6,6,6,6,6,6,6,6,6,6)  # ni's, the sample sizes, in Example 1
sdd=c(2.6,4.0,3.3,2.3,10.5,9.9,14.6,7.6,4.5,7.9) # sdi, the sample standard deviations 
kk=length(ybar)
k=kk-1
sss=sqrt(t(sdd^2)%*%(ni-1)/(sum(ni)-kk))   # the square root of the mean squared error

dosemean=cbind(ybar,ni)  
dosemean=dosemean[2:kk,]
pava=1:k
for (i in 1:k){
  mins=1:i
  for (s in 1:i){
    maxst=i:k
    for (t in i:k){
      ll=dosemean[s:t,] 
      if (length(ll)==2){maxst[t-i+1]=ll[1]*ll[2]/ll[2]}
      else {maxst[t-i+1]=(sum(ll[,1]*ll[,2]))/sum(ll[,2])}
    }
    mins[s]=min(maxst)
  }
  pava[i]=max(mins)
}

(pava-ybar[1]-delta)/sss   # this is test statistics. 1.0966327 is the first 
                           # larger than the cutoff point(see rcode2-cutci.r).
                           # Therefore, MED=4.